/*-
 * ~~~~~~licensing~~~~~~
 * cluster-persistence-service
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.core.cluster.persistence;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Base64;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Serializer<T> {

	private static final Logger log = LoggerFactory.getLogger(Serializer.class);
	
	
	private Class<T> dataClass;
	
	public Serializer(Class<T> clazz) {
		this.dataClass = clazz;
	} 
	
	public String toString(T object) {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
        ObjectOutputStream oos;
		try {
			oos = new ObjectOutputStream( baos );
	        oos.writeObject((Serializable) object);
	        oos.close();
		} catch (IOException e) {
			log.error("Serializer.toString", e);
		}
        return Base64.getEncoder().encodeToString(baos.toByteArray());			
	}
	
	public T fromString(String str) {
        byte [] data = Base64.getDecoder().decode(str);
        // ClassLoader original = Thread.currentThread().getContextClassLoader();
        // Thread.currentThread().setContextClassLoader(dataClass.getClassLoader());
        T result = null;
        try {
	        ObjectInputStream ois = new ObjectInputStream( 
	                                        new ByteArrayInputStream(  data ) );
	        Object o  = ois.readObject();
	        ois.close();
	        result = dataClass.cast(o);
        } catch (Exception e) {
        	result = null;
        }
        // Thread.currentThread().setContextClassLoader(original);
        return result;
	}
	
}
